CoreTTD = LibStub("AceAddon-3.0"):NewAddon("CoreTTD")

local tableTTD = {}
local timeToState = 0
time_left = 0
local targetGUID = 0
local indexTTD = 0

local function addTTD(value)
	tableTTD[value] = CreateFrame("frame", "TimeToDeathFrame"..value)
	tableTTD[value].tracked_rate = 0
	tableTTD[value].tableTarget = {}
	tableTTD[value].r, tableTTD[value].g, tableTTD[value].b, tableTTD[value].a = 1, 1, 1, 1
	tableTTD[value].cr, tableTTD[value].cg, tableTTD[value].cb, tableTTD[value].ca = 1, 0, 0, 1
	tableTTD[value].key = value
	tableTTD[value].timeToChange = 5
	tableTTD[value].size = 72
	tableTTD[value].precision = 1

	tableTTD[value]:SetMovable(true)
	tableTTD[value]:SetResizable(true)
	tableTTD[value]:EnableMouse(true)
	tableTTD[value]:RegisterForDrag("LeftButton")
	tableTTD[value]:SetScript("OnDragStart", tableTTD[value].StartMoving)
	tableTTD[value]:SetScript("OnDragStop", tableTTD[value].StopMovingOrSizing)
	tableTTD[value]:SetUserPlaced(true)
	tableTTD[value]:ClearAllPoints()
	tableTTD[value]:SetHeight(72)
	tableTTD[value]:SetWidth(3 * 72)
	tableTTD[value]:RegisterEvent("PLAYER_TARGET_CHANGED")
	tableTTD[value]:RegisterEvent("PLAYER_REGEN_DISABLED")
	tableTTD[value]:RegisterEvent("PLAYER_REGEN_ENABLED")
	tableTTD[value].ftstr = tableTTD[value]:CreateFontString(nil, "BACKGROUND")
	tableTTD[value].ftstr:SetAllPoints()
	tableTTD[value]:SetPoint("CENTER", 0, 200)
	tableTTD[value].ftstr:SetFont("Fonts\\FRIZQT__.TTF", 72)
	tableTTD[value].ftstr:SetText(time_left)
	--tableTTD[value]:Hide()
	tableTTD[value]:Show()

	local function changeTarget(self, event, ...)
		if event == "PLAYER_REGEN_ENABLED" then
			--tableTTD[value]:Hide()
			self.ftstr:SetTextColor(self.r, self.g, self.b, self.a)
		elseif UnitExists("target") and UnitCanAttack("player", "target") and UnitAffectingCombat("player") then
			targetGUID = UnitGUID("target")
			if (self.tableTarget[targetGUID] == nil) then self.tableTarget[targetGUID] = 0 end
			self.ftstr:SetText(time_left)
			--self:Show()
		end
	end

	tableTTD[value]:SetScript("OnEvent", changeTarget)

	local function onUpdate(self,elapsed)
		if UnitExists("target") and UnitCanAttack("player", "target") and UnitAffectingCombat("player") then
			local rate_life = UnitHealth("target") / UnitHealthMax("target")
			self.tableTarget[targetGUID] = self.tableTarget[targetGUID] + elapsed
			if rate_life <= self.tracked_rate then
				time_left = 0
				self.ftstr:SetTextColor(0, 0, 0, 1)
			elseif (rate_life < 1) then
				time_left = self.tableTarget[targetGUID] * (rate_life - self.tracked_rate) / (1 - rate_life)
				self.ftstr:SetTextColor(self.r, self.g, self.b, self.a)
			end
			self.ftstr:SetText(math.ceil(time_left * self.precision) / self.precision)
			if (time_left <= self.timeToChange) then
				self.ftstr:SetTextColor(self.cr, self.cg, self.cb, self.ca)
			end
		end
	end
	tableTTD[value]:SetScript("OnUpdate", onUpdate)
end


function setIndexTTD(value)
	indexTTD = value
end

function setTracked_rate(value)
	tableTTD[indexTTD].tracked_rate = value
	CoreTTD.db.profile.tableValue[indexTTD].tracked_rate = value
end

function getTracked_rate()
	return tableTTD[indexTTD].tracked_rate
end

function getFontColor()
	return tableTTD[indexTTD].ftstr:GetTextColor()
end

function setFontColor(r, g, b, a)
	tableTTD[indexTTD].r, tableTTD[indexTTD].g, tableTTD[indexTTD].b, tableTTD[indexTTD].a = r, g, b, a
	tableTTD[indexTTD].ftstr:SetTextColor(r, g, b, a)
	CoreTTD.db.profile.tableValue[indexTTD].r, CoreTTD.db.profile.tableValue[indexTTD].g, CoreTTD.db.profile.tableValue[indexTTD].b, CoreTTD.db.profile.tableValue[indexTTD].a = r, g, b, a
end

function setChangeFontColor(r, g, b, a)
	tableTTD[indexTTD].cr, tableTTD[indexTTD].cg, tableTTD[indexTTD].cb, tableTTD[indexTTD].ca = r, g, b, a
	CoreTTD.db.profile.tableValue[indexTTD].cr, CoreTTD.db.profile.tableValue[indexTTD].cg, CoreTTD.db.profile.tableValue[indexTTD].cb, CoreTTD.db.profile.tableValue[indexTTD].ca = r, g, b, a
end

function getChangeFontColor()
	return tableTTD[indexTTD].cr, tableTTD[indexTTD].cg, tableTTD[indexTTD].cb, tableTTD[indexTTD].ca
end

function setTimeToChange(t)
	tableTTD[indexTTD].timeToChange = t
	CoreTTD.db.profile.tableValue[indexTTD].timeToChange = t
end

function getTimeToChange()
	return tableTTD[indexTTD].timeToChange
end

function setSizeFrame(value)
	tableTTD[indexTTD].size = value
	CoreTTD.db.profile.tableValue[indexTTD].size = value
	tableTTD[indexTTD]:SetHeight(value)
	tableTTD[indexTTD]:SetWidth(3 * value)
	tableTTD[indexTTD].ftstr:SetFont("Fonts\\FRIZQT__.TTF", value)
end

function getSizeFrame()
	return tableTTD[indexTTD].size
end

function setPrecision(value)
	tableTTD[indexTTD].precision = value
	CoreTTD.db.profile.tableValue[indexTTD].precision = value
end

function getPrecision()
	return tableTTD[indexTTD].precision
end

local defaults = {
	profile = {
		tableValue = {}
	},
}

local function getTableTTD()
	local toRet = {}
	
	for key, _ in pairs(tableTTD) do
		toRet[key] = "Timer "..key
	end
	return toRet
end

function CoreTTD:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("CoreTTDDB", defaults)
	for key, value in pairs(self.db.profile.tableValue) do
		addTTD(value.key)
		setIndexTTD(value.key)
		setFontColor(value.r or 1, value.g or 1, value.b or 1, value.a or 1)
		setTimeToChange(value.timeToChange or 5)
		setTracked_rate(value.tracked_rate or 0)
		setChangeFontColor(value.cr or 1, value.cg or 0, value.cb or 0, value.ca or 1)
		setSizeFrame(value.size or 72)
		setPrecision(value.precision or 1)
	end
	setListSelect(getTableTTD())
end

function setNewTTD(value)
	addTTD(value)
	CoreTTD.db.profile.tableValue[value] = {}
	CoreTTD.db.profile.tableValue[value].r, CoreTTD.db.profile.tableValue[value].g, CoreTTD.db.profile.tableValue[value].b, CoreTTD.db.profile.tableValue[value].a = 1, 1, 1, 1
	CoreTTD.db.profile.tableValue[value].cr, CoreTTD.db.profile.tableValue[value].cg, CoreTTD.db.profile.tableValue[value].cb, CoreTTD.db.profile.tableValue[value].ca = 1, 0, 0, 1
	CoreTTD.db.profile.tableValue[value].timeToChange = 5
	CoreTTD.db.profile.tableValue[value].tracked_rate = 0
	CoreTTD.db.profile.tableValue[value].key = value
	CoreTTD.db.profile.tableValue[value].size = 72
	CoreTTD.db.profile.tableValue[value].precision = 1
end

function deleteTTD()
	tableTTD[indexTTD]:Hide()
	tableTTD[indexTTD] = nil
	CoreTTD.db.profile.tableValue[indexTTD] = nil
end